clear
clc;
format long e;
addpath('..');
path_to_files = '.\';


%--- load from Excel file ----
%--- correlation matrix
[CC,nms]=xlsread('Distributions_and_correlations.xls','Correlations','A1:E5');
M=size(CC,2);

%------------------------------------------------

%% Construct PROBLEM

N=4;
N=N*ones(1,M);

clear iargstruc_arr;
count=0;

%---------------------- Bounds on h_ --------------
j=0; cols={};
m=1; im=zeros(1,M);
while m>0
  im(m)=im(m)+1; if im(m)>N(m),im(m)=0; m=m-1; else m=m+1; end  
  if m>M,                                                                       % we have set of indexes im(:)
    j=j+1; cols{j}='h'; for jm=1:M; cols{j}=[cols{j} '_' int2str(im(jm))]; end
    m=m-1;   
  end    
end
kvars=j;      % A number of h_

%--------------- Matrix for Entropy ------------------------
count=count+1;
iargstruc_arr(count) = matrix_pack('matrix_uniform', ones(1,kvars), cols);  

%---------------------- Constraints on correlations --------
k=0;
j=0; cols={}; rows={}; vals=1;
w12=12; for jm=1:3; w12=w12/N(1); end                           % !!! ALL N(:) should be equal !!!
for ic=1:M-1; for jc=ic+1:M; rw=sprintf('R_%g_%g',ic,jc); k=k+1;
    m=1; im=zeros(1,M);
    while m>0
      im(m)=im(m)+1; if im(m)>N(m),im(m)=0; m=m-1; else m=m+1; end  
      if m>M,                                                   % we have set of indexes im(:)
         j=j+1; rows{j}=rw; cols{j}='h'; for jm=1:M; cols{j}=[cols{j} '_' int2str(im(jm))]; end
         vals(j)=w12*(im(ic)-1/2)*(im(jc)-1/2); 
        m=m-1;   
      end    
    end
    j=j+1; rows{j}=rw; cols{j}='scenario_benchmark'; vals(j)=-3-CC(ic,jc);
end; end
[cols,SparseMatrix]=Mmatrix2VarSparse(cols,rows,vals);
count=count+1; iargstruc_arr(count) = matrix_pack('matrix_constraint',full(SparseMatrix),cols);

%----------------------- Constraints on sum(h_) ---------
j=0; cols={}; rows={}; vals=1;
m=1; im=zeros(1,M);
while m>0                                                       % fill matrix by columns !!!
  im(m)=im(m)+1; if im(m)>N(m),im(m)=0; m=m-1; else m=m+1; end  
  if m>M,                                                       % we have set of indexes im(:)
    clm='h'; for jm=1:M; clm=[clm '_' num2str(im(jm))]; end
    for jm=1:M                                                  % one column is in M rows
      j=j+1; rows{j}=['R_',int2str(jm),'_',int2str(im(jm))]; cols{j}=clm; vals(j)=1;
    end
    m=m-1;   
  end    
end
[cols,SparseMatrix]=Mmatrix2VarSparse(cols,rows,vals);
sz=size(SparseMatrix,1);
%j=j+1; cols{j}='scenario_benchmark';
cols{size(cols,2)+1}='scenario_benchmark';
count=count+1; iargstruc_arr(count) = pmatrix_pack('pmatrix_sum',[SparseMatrix -ones(sz,1)],cols);

%--------------------- Problem statement ---------
problem_statement=sprintf('%s\n',...
'problem_findcopula_correlation, maximize', ...
'linearize = 1', ...
'  -entropyr(matrix_uniform)', ...
'Constraint: = 0', ...
'  linearmulti(matrix_constraint)', ...
'Constraint: = 0', ...
'  linearmulti(pmatrix_sum)', ...
'Box: >= 1e-13', ...
'Solver: buldozer, timelimit = 3600');

%-----------------------  Export problem to txt format -----
%mpsg_problem_exporttotext(problem_statement, iargstruc_arr, '.\');

%
%--------------------- Move problem into Tooolbox ------
%iargstruc_arr_new=tbpsg_convert_old_new(iargstruc_arr);
%tbpsg_toolbox(problem_statement, iargstruc_arr_new)

%---------------------- Solve problem by PSG in Matlab -----
[solution_str, outargstruc_arr] = mpsg_solver(problem_statement, iargstruc_arr);
%-------------------- Get solution and prepere output -----
optimal_point = get_solution(solution_str, outargstruc_arr, 'optimal_point');

disp('Optimal_point');
disp(optimal_point);

